<template>
    <div class="space_between">
        <div v-show='!phone_is_valid' class="space_between">
            <div>
                <div class="titles">
                    <div class="block-title active">{{$t('message.registration')}}</div>
                    <router-link to="/" class="block-title" exact>{{$t('message.enter_cabinet_title')}}</router-link>
                </div>
                <div class="input_container second">
                    <form @submit.prevent="send_phone" style='width:100%'>
                        <div class="input_component fix-margin">
                            <v-text-field
                                name="phone"
                                autocomplete="phone"
                                type="text"
                                :placeholder="$t('message.phone_placeholder')"
                                :class="[phone_err_msg ? 'error' : '']"
                                v-mask="mask"
                                @input="check_phone"
                                @focus="initMask"
                                v-model='phone'
                            >
                                <template slot="label">{{$t('message.phone_placeholder')}}</template>
                            </v-text-field>
                        </div>

                        <div v-if="!phone_is_valid && !phone_is_exist">
                            <div class="message error">{{phone_err_msg}}</div>
                        </div>

                        <div v-if="phone_is_exist">
                            <div class="message error">{{phone_err_msg}}</div>

                            <div class="message link">
                                <router-link :to="{ path:'/login', params: {phone: phone}}" class="block-title">
                                    {{$t('message.enter_cabinet_title')}}
                                </router-link>
                                <br/>
                                <router-link to="/reset" class="block-title">{{$t('message.forgot_password_title')}}
                                </router-link>
                            </div>
                        </div>

                        <div class="message">{{$t('message.receive_sms_text')}}</div>
                    </form>
                </div>
            </div>


            <div class="buttons">
                <button
                    @click="send_phone"
                    type='submit'
                    :disabled='!phone_is_enough || isLoading'
                    class="btn enter"
                >{{$t('message.send_sms')}}
                </button>
            </div>
        </div>

        <div v-show='phone_is_valid && !code_is_valid' class="space_between">
            <div>
                <div class="titles">
                    <div class="block-title active">{{$t('message.registration')}}</div>
                    <router-link to="/" class="block-title">{{$t('message.enter_cabinet_title')}}</router-link>
                </div>

                <div class="input_container second">
                    <button
                        @click='change_phone_before_validation'
                        type='button'
                        class="change_phone"
                    >{{$t('message.change_phone')}}
                    </button>

                    <div class="input_component fix-margin">
                        <input
                            id='code'
                            type='text'
                            v-model='code'
                            v-bind:placeholder="$t('message.check_your_phone')"
                            :class="[error ? 'error' : '']"
                            @input="error = ''"
                            @keyup.enter="send_code"
                            autocomplete="off"
                        >
                        <div class="lbl">{{$t('message.check_your_phone')}}</div>
                    </div>
                </div>
                <div class="message">{{$t('message.sent_sms')+phone}}</div>

                <div v-if="error" class="message error">{{$t('message.code_error')}}</div>

                <div v-if="after_timeout" @click="send_phone" class="message">
                    <span class="link">{{$t('message.code_again')}}</span>
                </div>
            </div>
            <div class="buttons">
                <button @click="send_code" type='submit' class="btn enter">{{$t('message.continue')}}</button>
            </div>
        </div>

        <div v-show='phone_is_valid && code_is_valid' class="space_between">
            <div>
                <div class="titles">
                    <div class="block-title active">{{$t('message.password_create')}}</div>
                </div>

                <a @click="$router.go(-1)" class="back_arrow">
                    <svg width="44" height="35" viewBox="0 0 44 35" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <g>
                            <rect x="16.9712" y="0.712891" width="2" height="23.3212"
                                  transform="rotate(45 16.9712 0.712891)"/>
                            <rect y="17.707" width="2" height="23.9822" transform="rotate(-45 0 17.707)"/>
                            <rect x="2.37598" y="18.7617" width="2" height="41"
                                  transform="rotate(-90 2.37598 18.7617)"/>
                        </g>
                    </svg>
                </a>

                <div class="input_container">
                    <div class="input_component fix-margin">
                        <input
                            id='password'
                            type='password'
                            v-model='password'
                            v-bind:placeholder="$t('message.create_password')"
                            :class="(password_errors.password || password_errors.c_password) ? 'error' : ''"
                            @keyup.enter="send_password"
                        >
                        <div class="lbl">{{$t('message.create_password')}}</div>
                    </div>
                </div>
                <div class="input_container second">
                    <div class="input_component fix-margin">
                        <input
                            id='c_password'
                            type='password'
                            v-model='c_password'
                            :placeholder="$t('message.confirm_password')"
                            :class="(password_errors.password || password_errors.c_password) ? 'error' : ''"
                            @keyup.enter="send_password"
                        >
                        <div class="lbl">{{$t('message.confirm_password')}}</div>
                    </div>
                </div>

                <label class="checkbox_group" :class='confirm_agreement ? "active" :  ""'>
                    <span class="radio"></span>
                    <span class="text">
                        {{$t('message.agreement_message')}} <a href=""
                                                               target="_blank">{{$t('message.agreement_link_message')}}</a>
                    </span>
                    <input type="checkbox" v-model="confirm_agreement">
                </label>

                <div
                    v-if="registration_error"
                    class="message error">
                    {{registration_error}}
                </div>
            </div>

            <div class="buttons">
                <button
                    :disabled='!confirm_agreement'
                    @click='send_password'
                    type='submit'
                    class="btn enter"
                >{{$t('message.continue')}}
                </button>
            </div>
        </div>
        <div v-if="isLoading" class="animation-container">
            <lottie :options="defaultOptions" :height="100" :width="100"/>
        </div>
    </div>
</template>

<script>
    import {mask} from 'vue-the-mask';
    import Lottie from 'vue-lottie';
    import * as animationData from "./animation/preload.json";

    export default {
        directives: {
            mask,
        },
        components: {
            'lottie': Lottie
        },
        data: () => {
            return {
                code: null,
                password: null,
                c_password: null,
                error: '',
                code_is_valid: null,
                confirm_agreement: false,
                after_timeout: false,
                mask: '+38 (0##) ###-##-##',
                isLoading: false,
                defaultOptions: {animationData: animationData.default},
                phone_is_valid: false,
                phone_is_exist: false,
                phone_err_msg: '',
            }
        },
        methods: {
            async send_phone() {
                this.isLoading = true;
                this.after_timeout = false;
                try {
                    const {data} = await axios.post('/register/set_phone', {phone: this.phone});
                    if (!data.is_valid) {
                        this.phone_err_msg = data[0].phone[0];
                        if (data.is_exist) {
                            this.phone_is_exist = data.is_exist;
                        }
                    }
                    this.phone_is_valid = data.is_valid;
                } catch (e) {}

                this.isLoading = false;
                setTimeout(() => {
                    this.after_timeout = true
                }, 30000);
                // this.$store.dispatch('validate_phone', this.phone);
                // this.after_timeout = false;
                // setTimeout(() => {
                //     this.after_timeout = true
                // }, 30000);
            },
            async send_code() {
                const {data} = await axios.post('/register/validate_code', {
                    code: this.code,
                    phone: this.phone
                });

                if (!data.is_valid){
                    this.error = 1;
                }
                this.code_is_valid = data.is_valid;
            },
            async send_password() {
                const {data} = await axios.post('/register', {
                    password: this.password,
                    c_password: this.c_password,
                    confirm_agreement: this.confirm_agreement
                });

                if (data.is_valid) {
                    this.$store.commit('refreshErrors');
                    this.$store.commit('set_errors', {});
                    this.$router.push('/profile');
                } else if(data[0]) {
                    this.$store.commit('set_password_err', data[0]);
                }
                this.$store.commit('set_password_status', data.is_valid);
            },
            check_phone() {
                // this.phone_is_enough = this.phone.length == 19;
                this.error = '';
            },
            change_phone() {
                this.$store.dispatch('validate_phone', null)
            },
            change_phone_before_validation() {
                this.$store.dispatch('reset_phone', null)
            },
            initMask() {
                this.phone = this.phone.length < 6 ? '+38 (0' : this.phone;
            }
        },
        computed: {
            password_is_valid: function () {
                return this.$store.getters.password_is_valid;
            },
            password_errors: function () {
                return this.$store.getters.password_errors;
            },
            registration_error: function () {
                if (this.password_errors.password)
                    return this.password_errors.password[0];
                else if (this.password_errors.c_password)
                    return this.password_errors.c_password[0];
                else if (this.password_errors.confirm_agreement)
                    return this.password_errors.confirm_agreement[0];
                else false
            },
            phone: {
                set: function (n) {
                    this.$store.dispatch('set_phone', n)
                },
                get: function () {
                    return this.$store.getters.phone
                },
            },
            phone_is_enough: function () {
                return this.phone.length == 19;
            }
        },
        created() {
            const seo = {
                title: 'Зареєстуйтеся',
                description: 'Створюйте свій особистий профіль',
                keywords: 'Реєстрація',
                h1: 'Реєстрація'
            }
            document.title = seo.title;
            document.querySelector('head meta[name="description"]').setAttribute('content', seo.description);
            document.querySelector('head meta[name="keywords"]').setAttribute('content', seo.keywords);
            this.$emit('set-h1', seo.h1);
        },
        beforeDestroy() {
            this.$store.commit('refreshErrors');
        }
    }
</script>
